# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['FinalizeVersionUpgradeArgs', 'FinalizeVersionUpgrade']

@pulumi.input_type
class FinalizeVersionUpgradeArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 cockroach_version: pulumi.Input[str]):
        """
        The set of arguments for constructing a FinalizeVersionUpgrade resource.
        :param pulumi.Input[str] cluster_id: Cluster ID
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "cockroach_version", cockroach_version)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        Cluster ID
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="cockroachVersion")
    def cockroach_version(self) -> pulumi.Input[str]:
        return pulumi.get(self, "cockroach_version")

    @cockroach_version.setter
    def cockroach_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "cockroach_version", value)


@pulumi.input_type
class _FinalizeVersionUpgradeState:
    def __init__(__self__, *,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cockroach_version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering FinalizeVersionUpgrade resources.
        :param pulumi.Input[str] cluster_id: Cluster ID
        """
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if cockroach_version is not None:
            pulumi.set(__self__, "cockroach_version", cockroach_version)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        Cluster ID
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="cockroachVersion")
    def cockroach_version(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cockroach_version")

    @cockroach_version.setter
    def cockroach_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cockroach_version", value)


class FinalizeVersionUpgrade(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cockroach_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Utility resource that represents the one-time action of finalizing a cluster's pending CockroachDB version upgrade.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: Cluster ID
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FinalizeVersionUpgradeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Utility resource that represents the one-time action of finalizing a cluster's pending CockroachDB version upgrade.

        :param str resource_name: The name of the resource.
        :param FinalizeVersionUpgradeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FinalizeVersionUpgradeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 cockroach_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FinalizeVersionUpgradeArgs.__new__(FinalizeVersionUpgradeArgs)

            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            if cockroach_version is None and not opts.urn:
                raise TypeError("Missing required property 'cockroach_version'")
            __props__.__dict__["cockroach_version"] = cockroach_version
        super(FinalizeVersionUpgrade, __self__).__init__(
            'cockroach:index/finalizeVersionUpgrade:FinalizeVersionUpgrade',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            cockroach_version: Optional[pulumi.Input[str]] = None) -> 'FinalizeVersionUpgrade':
        """
        Get an existing FinalizeVersionUpgrade resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: Cluster ID
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FinalizeVersionUpgradeState.__new__(_FinalizeVersionUpgradeState)

        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["cockroach_version"] = cockroach_version
        return FinalizeVersionUpgrade(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        Cluster ID
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="cockroachVersion")
    def cockroach_version(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cockroach_version")

