# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'ClusterDedicated',
    'ClusterRegion',
    'ClusterServerless',
    'ClusterServerlessUsageLimits',
    'CmekAdditionalRegion',
    'CmekRegion',
    'CmekRegionKey',
    'LogExportConfigGroup',
    'PrivateEndpointServicesService',
    'PrivateEndpointServicesServiceAws',
    'UserRoleGrantsRole',
    'GetCockroachClusterDedicatedResult',
    'GetCockroachClusterRegionResult',
    'GetCockroachClusterServerlessResult',
    'GetCockroachClusterServerlessUsageLimitsResult',
]

@pulumi.output_type
class ClusterDedicated(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "diskIops":
            suggest = "disk_iops"
        elif key == "machineType":
            suggest = "machine_type"
        elif key == "memoryGib":
            suggest = "memory_gib"
        elif key == "numVirtualCpus":
            suggest = "num_virtual_cpus"
        elif key == "privateNetworkVisibility":
            suggest = "private_network_visibility"
        elif key == "storageGib":
            suggest = "storage_gib"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterDedicated. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterDedicated.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterDedicated.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disk_iops: Optional[int] = None,
                 machine_type: Optional[str] = None,
                 memory_gib: Optional[float] = None,
                 num_virtual_cpus: Optional[int] = None,
                 private_network_visibility: Optional[bool] = None,
                 storage_gib: Optional[int] = None):
        """
        :param bool private_network_visibility: Set to true to assign private IP addresses to nodes. Required for CMEK and other advanced networking features.
        """
        if disk_iops is not None:
            pulumi.set(__self__, "disk_iops", disk_iops)
        if machine_type is not None:
            pulumi.set(__self__, "machine_type", machine_type)
        if memory_gib is not None:
            pulumi.set(__self__, "memory_gib", memory_gib)
        if num_virtual_cpus is not None:
            pulumi.set(__self__, "num_virtual_cpus", num_virtual_cpus)
        if private_network_visibility is not None:
            pulumi.set(__self__, "private_network_visibility", private_network_visibility)
        if storage_gib is not None:
            pulumi.set(__self__, "storage_gib", storage_gib)

    @property
    @pulumi.getter(name="diskIops")
    def disk_iops(self) -> Optional[int]:
        return pulumi.get(self, "disk_iops")

    @property
    @pulumi.getter(name="machineType")
    def machine_type(self) -> Optional[str]:
        return pulumi.get(self, "machine_type")

    @property
    @pulumi.getter(name="memoryGib")
    def memory_gib(self) -> Optional[float]:
        return pulumi.get(self, "memory_gib")

    @property
    @pulumi.getter(name="numVirtualCpus")
    def num_virtual_cpus(self) -> Optional[int]:
        return pulumi.get(self, "num_virtual_cpus")

    @property
    @pulumi.getter(name="privateNetworkVisibility")
    def private_network_visibility(self) -> Optional[bool]:
        """
        Set to true to assign private IP addresses to nodes. Required for CMEK and other advanced networking features.
        """
        return pulumi.get(self, "private_network_visibility")

    @property
    @pulumi.getter(name="storageGib")
    def storage_gib(self) -> Optional[int]:
        return pulumi.get(self, "storage_gib")


@pulumi.output_type
class ClusterRegion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nodeCount":
            suggest = "node_count"
        elif key == "sqlDns":
            suggest = "sql_dns"
        elif key == "uiDns":
            suggest = "ui_dns"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterRegion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterRegion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterRegion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 node_count: Optional[int] = None,
                 primary: Optional[bool] = None,
                 sql_dns: Optional[str] = None,
                 ui_dns: Optional[str] = None):
        """
        :param str name: Name of cluster
        :param bool primary: Set to true to mark this region as the primary for a Serverless cluster. Exactly one region must be primary. Dedicated clusters expect to have no primary region.
        """
        pulumi.set(__self__, "name", name)
        if node_count is not None:
            pulumi.set(__self__, "node_count", node_count)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)
        if sql_dns is not None:
            pulumi.set(__self__, "sql_dns", sql_dns)
        if ui_dns is not None:
            pulumi.set(__self__, "ui_dns", ui_dns)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of cluster
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeCount")
    def node_count(self) -> Optional[int]:
        return pulumi.get(self, "node_count")

    @property
    @pulumi.getter
    def primary(self) -> Optional[bool]:
        """
        Set to true to mark this region as the primary for a Serverless cluster. Exactly one region must be primary. Dedicated clusters expect to have no primary region.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="sqlDns")
    def sql_dns(self) -> Optional[str]:
        return pulumi.get(self, "sql_dns")

    @property
    @pulumi.getter(name="uiDns")
    def ui_dns(self) -> Optional[str]:
        return pulumi.get(self, "ui_dns")


@pulumi.output_type
class ClusterServerless(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "routingId":
            suggest = "routing_id"
        elif key == "spendLimit":
            suggest = "spend_limit"
        elif key == "usageLimits":
            suggest = "usage_limits"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterServerless. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterServerless.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterServerless.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 routing_id: Optional[str] = None,
                 spend_limit: Optional[int] = None,
                 usage_limits: Optional['outputs.ClusterServerlessUsageLimits'] = None):
        """
        :param int spend_limit: Spend limit in US cents.
        """
        if routing_id is not None:
            pulumi.set(__self__, "routing_id", routing_id)
        if spend_limit is not None:
            pulumi.set(__self__, "spend_limit", spend_limit)
        if usage_limits is not None:
            pulumi.set(__self__, "usage_limits", usage_limits)

    @property
    @pulumi.getter(name="routingId")
    def routing_id(self) -> Optional[str]:
        return pulumi.get(self, "routing_id")

    @property
    @pulumi.getter(name="spendLimit")
    def spend_limit(self) -> Optional[int]:
        """
        Spend limit in US cents.
        """
        return pulumi.get(self, "spend_limit")

    @property
    @pulumi.getter(name="usageLimits")
    def usage_limits(self) -> Optional['outputs.ClusterServerlessUsageLimits']:
        return pulumi.get(self, "usage_limits")


@pulumi.output_type
class ClusterServerlessUsageLimits(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "requestUnitLimit":
            suggest = "request_unit_limit"
        elif key == "storageMibLimit":
            suggest = "storage_mib_limit"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterServerlessUsageLimits. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterServerlessUsageLimits.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterServerlessUsageLimits.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 request_unit_limit: int,
                 storage_mib_limit: int):
        pulumi.set(__self__, "request_unit_limit", request_unit_limit)
        pulumi.set(__self__, "storage_mib_limit", storage_mib_limit)

    @property
    @pulumi.getter(name="requestUnitLimit")
    def request_unit_limit(self) -> int:
        return pulumi.get(self, "request_unit_limit")

    @property
    @pulumi.getter(name="storageMibLimit")
    def storage_mib_limit(self) -> int:
        return pulumi.get(self, "storage_mib_limit")


@pulumi.output_type
class CmekAdditionalRegion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nodeCount":
            suggest = "node_count"
        elif key == "sqlDns":
            suggest = "sql_dns"
        elif key == "uiDns":
            suggest = "ui_dns"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CmekAdditionalRegion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CmekAdditionalRegion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CmekAdditionalRegion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 node_count: Optional[int] = None,
                 primary: Optional[bool] = None,
                 sql_dns: Optional[str] = None,
                 ui_dns: Optional[str] = None):
        """
        :param bool primary: Set to true to mark this region as the primary for a Serverless cluster. Exactly one region must be primary. Dedicated clusters expect to have no primary region.
        """
        pulumi.set(__self__, "name", name)
        if node_count is not None:
            pulumi.set(__self__, "node_count", node_count)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)
        if sql_dns is not None:
            pulumi.set(__self__, "sql_dns", sql_dns)
        if ui_dns is not None:
            pulumi.set(__self__, "ui_dns", ui_dns)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeCount")
    def node_count(self) -> Optional[int]:
        return pulumi.get(self, "node_count")

    @property
    @pulumi.getter
    def primary(self) -> Optional[bool]:
        """
        Set to true to mark this region as the primary for a Serverless cluster. Exactly one region must be primary. Dedicated clusters expect to have no primary region.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="sqlDns")
    def sql_dns(self) -> Optional[str]:
        return pulumi.get(self, "sql_dns")

    @property
    @pulumi.getter(name="uiDns")
    def ui_dns(self) -> Optional[str]:
        return pulumi.get(self, "ui_dns")


@pulumi.output_type
class CmekRegion(dict):
    def __init__(__self__, *,
                 key: 'outputs.CmekRegionKey',
                 region: str,
                 status: Optional[str] = None):
        """
        :param str status: Aggregated status of the cluster's encryption key(s)
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "region", region)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def key(self) -> 'outputs.CmekRegionKey':
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Aggregated status of the cluster's encryption key(s)
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class CmekRegionKey(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "authPrincipal":
            suggest = "auth_principal"
        elif key == "createdAt":
            suggest = "created_at"
        elif key == "updatedAt":
            suggest = "updated_at"
        elif key == "userMessage":
            suggest = "user_message"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CmekRegionKey. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CmekRegionKey.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CmekRegionKey.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auth_principal: str,
                 type: str,
                 uri: str,
                 created_at: Optional[str] = None,
                 status: Optional[str] = None,
                 updated_at: Optional[str] = None,
                 user_message: Optional[str] = None):
        """
        :param str status: Aggregated status of the cluster's encryption key(s)
        """
        pulumi.set(__self__, "auth_principal", auth_principal)
        pulumi.set(__self__, "type", type)
        pulumi.set(__self__, "uri", uri)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if user_message is not None:
            pulumi.set(__self__, "user_message", user_message)

    @property
    @pulumi.getter(name="authPrincipal")
    def auth_principal(self) -> str:
        return pulumi.get(self, "auth_principal")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uri(self) -> str:
        return pulumi.get(self, "uri")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Aggregated status of the cluster's encryption key(s)
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="userMessage")
    def user_message(self) -> Optional[str]:
        return pulumi.get(self, "user_message")


@pulumi.output_type
class LogExportConfigGroup(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logName":
            suggest = "log_name"
        elif key == "minLevel":
            suggest = "min_level"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LogExportConfigGroup. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LogExportConfigGroup.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LogExportConfigGroup.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 channels: Sequence[str],
                 log_name: str,
                 min_level: Optional[str] = None,
                 redact: Optional[bool] = None):
        """
        :param Sequence[str] channels: A list of CRDB log channels to include in this group
        :param str log_name: The name of the group, reflected in the log sink
        :param str min_level: The minimum log level to filter to this log group
        :param bool redact: Governs whether this log group should aggregate redacted logs if unset
        """
        pulumi.set(__self__, "channels", channels)
        pulumi.set(__self__, "log_name", log_name)
        if min_level is not None:
            pulumi.set(__self__, "min_level", min_level)
        if redact is not None:
            pulumi.set(__self__, "redact", redact)

    @property
    @pulumi.getter
    def channels(self) -> Sequence[str]:
        """
        A list of CRDB log channels to include in this group
        """
        return pulumi.get(self, "channels")

    @property
    @pulumi.getter(name="logName")
    def log_name(self) -> str:
        """
        The name of the group, reflected in the log sink
        """
        return pulumi.get(self, "log_name")

    @property
    @pulumi.getter(name="minLevel")
    def min_level(self) -> Optional[str]:
        """
        The minimum log level to filter to this log group
        """
        return pulumi.get(self, "min_level")

    @property
    @pulumi.getter
    def redact(self) -> Optional[bool]:
        """
        Governs whether this log group should aggregate redacted logs if unset
        """
        return pulumi.get(self, "redact")


@pulumi.output_type
class PrivateEndpointServicesService(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "cloudProvider":
            suggest = "cloud_provider"
        elif key == "regionName":
            suggest = "region_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PrivateEndpointServicesService. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PrivateEndpointServicesService.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PrivateEndpointServicesService.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 aws: Optional['outputs.PrivateEndpointServicesServiceAws'] = None,
                 cloud_provider: Optional[str] = None,
                 region_name: Optional[str] = None,
                 status: Optional[str] = None):
        if aws is not None:
            pulumi.set(__self__, "aws", aws)
        if cloud_provider is not None:
            pulumi.set(__self__, "cloud_provider", cloud_provider)
        if region_name is not None:
            pulumi.set(__self__, "region_name", region_name)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def aws(self) -> Optional['outputs.PrivateEndpointServicesServiceAws']:
        return pulumi.get(self, "aws")

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> Optional[str]:
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="regionName")
    def region_name(self) -> Optional[str]:
        return pulumi.get(self, "region_name")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        return pulumi.get(self, "status")


@pulumi.output_type
class PrivateEndpointServicesServiceAws(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "availabilityZoneIds":
            suggest = "availability_zone_ids"
        elif key == "serviceId":
            suggest = "service_id"
        elif key == "serviceName":
            suggest = "service_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PrivateEndpointServicesServiceAws. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PrivateEndpointServicesServiceAws.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PrivateEndpointServicesServiceAws.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 availability_zone_ids: Optional[Sequence[str]] = None,
                 service_id: Optional[str] = None,
                 service_name: Optional[str] = None):
        if availability_zone_ids is not None:
            pulumi.set(__self__, "availability_zone_ids", availability_zone_ids)
        if service_id is not None:
            pulumi.set(__self__, "service_id", service_id)
        if service_name is not None:
            pulumi.set(__self__, "service_name", service_name)

    @property
    @pulumi.getter(name="availabilityZoneIds")
    def availability_zone_ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "availability_zone_ids")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[str]:
        return pulumi.get(self, "service_id")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> Optional[str]:
        return pulumi.get(self, "service_name")


@pulumi.output_type
class UserRoleGrantsRole(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resourceType":
            suggest = "resource_type"
        elif key == "roleName":
            suggest = "role_name"
        elif key == "resourceId":
            suggest = "resource_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in UserRoleGrantsRole. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        UserRoleGrantsRole.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        UserRoleGrantsRole.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 resource_type: str,
                 role_name: str,
                 resource_id: Optional[str] = None):
        pulumi.set(__self__, "resource_type", resource_type)
        pulumi.set(__self__, "role_name", role_name)
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> str:
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> str:
        return pulumi.get(self, "role_name")

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[str]:
        return pulumi.get(self, "resource_id")


@pulumi.output_type
class GetCockroachClusterDedicatedResult(dict):
    def __init__(__self__, *,
                 disk_iops: int,
                 machine_type: str,
                 memory_gib: float,
                 num_virtual_cpus: int,
                 private_network_visibility: bool,
                 storage_gib: int):
        pulumi.set(__self__, "disk_iops", disk_iops)
        pulumi.set(__self__, "machine_type", machine_type)
        pulumi.set(__self__, "memory_gib", memory_gib)
        pulumi.set(__self__, "num_virtual_cpus", num_virtual_cpus)
        pulumi.set(__self__, "private_network_visibility", private_network_visibility)
        pulumi.set(__self__, "storage_gib", storage_gib)

    @property
    @pulumi.getter(name="diskIops")
    def disk_iops(self) -> int:
        return pulumi.get(self, "disk_iops")

    @property
    @pulumi.getter(name="machineType")
    def machine_type(self) -> str:
        return pulumi.get(self, "machine_type")

    @property
    @pulumi.getter(name="memoryGib")
    def memory_gib(self) -> float:
        return pulumi.get(self, "memory_gib")

    @property
    @pulumi.getter(name="numVirtualCpus")
    def num_virtual_cpus(self) -> int:
        return pulumi.get(self, "num_virtual_cpus")

    @property
    @pulumi.getter(name="privateNetworkVisibility")
    def private_network_visibility(self) -> bool:
        return pulumi.get(self, "private_network_visibility")

    @property
    @pulumi.getter(name="storageGib")
    def storage_gib(self) -> int:
        return pulumi.get(self, "storage_gib")


@pulumi.output_type
class GetCockroachClusterRegionResult(dict):
    def __init__(__self__, *,
                 name: str,
                 node_count: int,
                 primary: bool,
                 sql_dns: str,
                 ui_dns: str):
        """
        :param str name: Name of cluster
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "node_count", node_count)
        pulumi.set(__self__, "primary", primary)
        pulumi.set(__self__, "sql_dns", sql_dns)
        pulumi.set(__self__, "ui_dns", ui_dns)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of cluster
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeCount")
    def node_count(self) -> int:
        return pulumi.get(self, "node_count")

    @property
    @pulumi.getter
    def primary(self) -> bool:
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="sqlDns")
    def sql_dns(self) -> str:
        return pulumi.get(self, "sql_dns")

    @property
    @pulumi.getter(name="uiDns")
    def ui_dns(self) -> str:
        return pulumi.get(self, "ui_dns")


@pulumi.output_type
class GetCockroachClusterServerlessResult(dict):
    def __init__(__self__, *,
                 routing_id: str,
                 spend_limit: int,
                 usage_limits: 'outputs.GetCockroachClusterServerlessUsageLimitsResult'):
        pulumi.set(__self__, "routing_id", routing_id)
        pulumi.set(__self__, "spend_limit", spend_limit)
        pulumi.set(__self__, "usage_limits", usage_limits)

    @property
    @pulumi.getter(name="routingId")
    def routing_id(self) -> str:
        return pulumi.get(self, "routing_id")

    @property
    @pulumi.getter(name="spendLimit")
    def spend_limit(self) -> int:
        return pulumi.get(self, "spend_limit")

    @property
    @pulumi.getter(name="usageLimits")
    def usage_limits(self) -> 'outputs.GetCockroachClusterServerlessUsageLimitsResult':
        return pulumi.get(self, "usage_limits")


@pulumi.output_type
class GetCockroachClusterServerlessUsageLimitsResult(dict):
    def __init__(__self__, *,
                 request_unit_limit: int,
                 storage_mib_limit: int):
        pulumi.set(__self__, "request_unit_limit", request_unit_limit)
        pulumi.set(__self__, "storage_mib_limit", storage_mib_limit)

    @property
    @pulumi.getter(name="requestUnitLimit")
    def request_unit_limit(self) -> int:
        return pulumi.get(self, "request_unit_limit")

    @property
    @pulumi.getter(name="storageMibLimit")
    def storage_mib_limit(self) -> int:
        return pulumi.get(self, "storage_mib_limit")


